﻿/**
  *  1. Create a store class that will be generic and will accept Potato and Carrot classes.
  *      - Choose a collection that will best fit the shop.
  *      - Make a function that will allow you to get a sum of this previously mentioned collection .
  *  
  *  2. Once you are finished, created extension functions that will do the following:
  *      - PrintInfoAboutStore -> Prints info about what does the shop contain.
  *      - TakeItemFromTheShop -> Takes item from the stop collection.
  *      - ReturnItemToShop -> Returns item back to the shop.
  *      
  *  3. Shopkeep should be capable of making the following actions:
  *      - CalculateCartPrice - returns the price of the cart.
  *      - ReturnItems - returns items from Cart to Shop.
  *      
  *  4. Customer should be capable of making the following actions:
  *      - AddItemToCart - add item to cart.
  *      - RemoveItemFromCart - remove item from cart.
  *      - MakePurchase - makes a purchase (check the ballence!).
  *  
  *  5. Create a small demo, where you will show that everything works as intended.
  *  
  *  6. Make sure that you cannot pass any other than IProductable interface.
  *  
  *  Bonus: Test your work!
  *  
  *  Bonus v2.0: Try the following:
  *      
  *      - Instead of using cart, make a CashRegister class that will represent a cart, but only in a small shop,
  *        where you can only tell the shopkeep what you want (for instance -> bufet na fi).
  *          - For a bit of a challange, do not pass this CashRegister as a parameter. 
  *      
  */


using cvicenie_04_aktivitka.Store;

var potate = new Potato();
var carrot = new Carrot();

Console.WriteLine("Hello and welcome to our shop");

var store = new Store<IProductable>()
{
    Items = new Dictionary<IProductable, int> {
        { potate, 5 },
        { carrot, 20 }
    }
};

Console.WriteLine("Creating people");
var customer = new Customer { Ballance = 1000, Name = "Ferko" };
var employee = new Shopkeep { EmployeeID = 2, Name = "Janko" };

store.PrintInfoAboutStore<IProductable>();

Console.WriteLine("Adding to Cart");
customer.AddItemToCart<IProductable>(store, potate);
customer.AddItemToCart<IProductable>(store, potate);
customer.AddItemToCart<IProductable>(store, potate);
customer.MakePurchase<IProductable>(store);

store.PrintInfoAboutStore<IProductable>();

foreach (var item in CashRegister<IProductable>.Audit)
    Console.WriteLine($"Cart - {item.ItemName} -> {item.Price}");

customer.AddItemToCart<IProductable>(store, potate);
customer.AddItemToCart<IProductable>(store, potate);
store.PrintInfoAboutStore<IProductable>();

Console.WriteLine("Employee work");
employee.CalculatePrice<IProductable>();
employee.ReturnItems<IProductable>(store);

store.PrintInfoAboutStore<IProductable>();
