﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace cvicenie_04_aktivitka.Store
{
    // DO NOT MODIFY THIS CLASS!
    public class Customer
    {
        public double Ballance { get; set; }
        public string Name { get; set; }
    }

    public static class CustomerExtensions
    {
        public static void AddItemToCart<T>(this Customer c, Store<T> t, T item) where T : IProductable
        {
            Console.WriteLine(t.Items.TryGetValue(item, out var _));

            t.AddItemToCart(item);
            CashRegister<T>.Audit.Add(item);
        }

        public static void RemoveItemFromCart<T>(this Customer c, Store<T> t, T item) where T : IProductable
        {
            t.ReturnItemToShop(item);
            CashRegister<T>.Audit.Remove(item);
        }

        public static double MakePurchase<T>(this Customer c, Store<T> t) where T : IProductable
        {
            var sum = CashRegister<T>.Audit.Sum(a => a.Price);

            if (c.Ballance < sum)
                throw new ArgumentException("Not enough ballance");

            c.Ballance -= sum;

            CashRegister<T>.Audit = new List<T>();
            return sum;
        }
    }
}
